图像可以附着并放置在图形文件中,但它们实际上不是文件的一部分。图像通过路径名或数据管理文档 ID 链接到图形文件,链接的图像路径可以随时更改或删除。若要附加映像,首先创建一个对象,其中包含有关存储在所引用磁盘上的映像文件的定义信息,然后创建一个对象。RasterImageDefRasterImage 创建对象后,将其分配给对象。该对象表示您在绘图窗口中与之交互的对象,并允许您控制图像的插入点、比例、方向和外观以及其他属性。单个对象可用于多次附加图像。每个附件都有自己的剪辑边界和自己的亮度、对比度、淡入淡出和透明度设置。RasterImageDefRasterImageRasterImageRasterImageDef 创建对象后,可以使用“比例”属性设置光栅图像的比例因子,以便图像的几何比例与在 AutoCAD 图形中创建的几何图形的比例相匹配。附着图像时,图像将以 1 个图像测量单位到 1 个 AutoCAD 测量单位的比例因子插入。若要设置图像比例系数,需要知道图像上几何图形的比例,并且需要知道要使用哪种度量单位(英寸、英尺等)来定义 1 个 AutoCAD 单位。图像文件必须包含定义 DPI、每英寸点数和图像像素数的分辨率信息。RasterImage 如果图像具有分辨率信息,AutoCAD 会将其与您提供的比例因子和 AutoCAD 度量单位相结合,以缩放图形中的图像。例如,如果光栅图像是比例为 1 英寸等于 50 英尺或 1:600 的扫描蓝图,并且将 AutoCAD 图形设置为 1 单位表示 1 英寸,则将图像的比例系数设置为 600。AutoCAD 缩放图像,使图像中的几何图形与图形中的矢量几何图形对齐。 注意:如果未在附着的图像文件中定义分辨率信息,则 AutoCAD 会将图像的原始宽度作为一个单位进行计算。插入后,以 AutoCAD 为单位的图像宽度等于比例因子。
附加光栅图像本示例在模型空间中添加栅格图像。此示例使用在 VBA 示例目录中找到的 WorldMap.tif 文件。如果没有此映像,或者它位于其他目录中,请修改代码以使用有效的路径和文件名。 VB.NETImports Autodesk.AutoCAD.Runtime Imports Autodesk.AutoCAD.ApplicationServices Imports Autodesk.AutoCAD.DatabaseServices Imports Autodesk.AutoCAD.Geometry <CommandMethod("AttachRasterImage")> _ Public Sub AttachRasterImage() ' Get the current database and start a transaction Dim acCurDb As Autodesk.AutoCAD.DatabaseServices.Database acCurDb = Application.DocumentManager.MdiActiveDocument.Database Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction() ' Define the name and image to use Dim strImgName As String = "WorldMap" Dim strFileName As String = "C:\AutoCAD\Sample\VBA\WorldMap.TIF" Dim acRasterDef As RasterImageDef Dim bRasterDefCreated As Boolean = False Dim acImgDefId As ObjectId ' Get the image dictionary Dim acImgDctID As ObjectId = RasterImageDef.GetImageDictionary(acCurDb) ' Check to see if the dictionary does not exist, it not then create it If acImgDctID.IsNull Then acImgDctID = RasterImageDef.CreateImageDictionary(acCurDb) End If ' Open the image dictionary Dim acImgDict As DBDictionary = acTrans.GetObject(acImgDctID, OpenMode.ForRead) ' Check to see if the image definition already exists If acImgDict.Contains(strImgName) Then acImgDefId = acImgDict.GetAt(strImgName) acRasterDef = acTrans.GetObject(acImgDefId, OpenMode.ForWrite) Else ' Create a raster image definition Dim acRasterDefNew As New RasterImageDef ' Set the source for the image file acRasterDefNew.SourceFileName = strFileName ' Load the image into memory acRasterDefNew.Load() ' Add the image definition to the dictionary acTrans.GetObject(acImgDctID, OpenMode.ForWrite) acImgDefId = acImgDict.SetAt(strImgName, acRasterDefNew) acTrans.AddNewlyCreatedDBObject(acRasterDefNew, True) acRasterDef = acRasterDefNew bRasterDefCreated = True End If ' Open the Block table for read Dim acBlkTbl As BlockTable acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, OpenMode.ForRead) ' Open the Block table record Model space for write Dim acBlkTblRec As BlockTableRecord acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), _ OpenMode.ForWrite) ' Create the new image and assign it the image definition Using acRaster As New RasterImage acRaster.ImageDefId = acImgDefId ' Use ImageWidth and ImageHeight to get the size of the image in pixels (1024 x 768). ' Use ResolutionMMPerPixel to determine the number of millimeters in a pixel so you ' can convert the size of the drawing into other units or millimeters based on the ' drawing units used in the current drawing. ' Define the width and height of the image Dim width As Vector3d Dim height As Vector3d ' Check to see if the measurement is set to English (Imperial) or Metric units If acCurDb.Measurement = MeasurementValue.English Then width = New Vector3d((acRasterDef.ResolutionMMPerPixel.X * acRaster.ImageWidth) / 25.4, 0, 0) height = New Vector3d(0, (acRasterDef.ResolutionMMPerPixel.Y * acRaster.ImageHeight) / 25.4, 0) Else width = New Vector3d(acRasterDef.ResolutionMMPerPixel.X * acRaster.ImageWidth, 0, 0) height = New Vector3d(0, acRasterDef.ResolutionMMPerPixel.Y * acRaster.ImageHeight, 0) End If ' Define the position for the image Dim insPt As New Point3d(5.0, 5.0, 0.0) ' Define and assign a coordinate system for the image's orientation Dim coordinateSystem As New CoordinateSystem3d(insPt, width * 2, height * 2) acRaster.Orientation = coordinateSystem ' Set the rotation angle for the image acRaster.Rotation = 0 ' Add the new object to the block table record and the transaction acBlkTblRec.AppendEntity(acRaster) acTrans.AddNewlyCreatedDBObject(acRaster, True) ' Connect the raster definition and image together so the definition ' does not appear as "unreferenced" in the External References palette. RasterImage.EnableReactors(True) acRaster.AssociateRasterDef(acRasterDef) If bRasterDefCreated Then acRasterDef.Dispose() End If End Using ' Save the new object to the database acTrans.Commit() ' Dispose of the transaction End Using End Sub C#using Autodesk.AutoCAD.Runtime; using Autodesk.AutoCAD.ApplicationServices; using Autodesk.AutoCAD.DatabaseServices; using Autodesk.AutoCAD.Geometry; [CommandMethod("AttachRasterImage")] public void AttachRasterImage() { // Get the current database and start a transaction Database acCurDb; acCurDb = Application.DocumentManager.MdiActiveDocument.Database; using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction()) { // Define the name and image to use string strImgName = "WorldMap"; string strFileName = "C:\\AutoCAD\\Sample\\VBA\\WorldMap.TIF"; RasterImageDef acRasterDef; bool bRasterDefCreated = false; ObjectId acImgDefId; // Get the image dictionary ObjectId acImgDctID = RasterImageDef.GetImageDictionary(acCurDb); // Check to see if the dictionary does not exist, it not then create it if (acImgDctID.IsNull) { acImgDctID = RasterImageDef.CreateImageDictionary(acCurDb); } // Open the image dictionary DBDictionary acImgDict = acTrans.GetObject(acImgDctID, OpenMode.ForRead) as DBDictionary; // Check to see if the image definition already exists if (acImgDict.Contains(strImgName)) { acImgDefId = acImgDict.GetAt(strImgName); acRasterDef = acTrans.GetObject(acImgDefId, OpenMode.ForWrite) as RasterImageDef; } else { // Create a raster image definition RasterImageDef acRasterDefNew = new RasterImageDef(); // Set the source for the image file acRasterDefNew.SourceFileName = strFileName; // Load the image into memory acRasterDefNew.Load(); // Add the image definition to the dictionary acTrans.GetObject(acImgDctID, OpenMode.ForWrite); acImgDefId = acImgDict.SetAt(strImgName, acRasterDefNew); acTrans.AddNewlyCreatedDBObject(acRasterDefNew, true); acRasterDef = acRasterDefNew; bRasterDefCreated = true; } // Open the Block table for read BlockTable acBlkTbl; acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, OpenMode.ForRead) as BlockTable; // Open the Block table record Model space for write BlockTableRecord acBlkTblRec; acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord; // Create the new image and assign it the image definition using (RasterImage acRaster = new RasterImage()) { acRaster.ImageDefId = acImgDefId; // Use ImageWidth and ImageHeight to get the size of the image in pixels (1024 x 768). // Use ResolutionMMPerPixel to determine the number of millimeters in a pixel so you // can convert the size of the drawing into other units or millimeters based on the // drawing units used in the current drawing. // Define the width and height of the image Vector3d width; Vector3d height; // Check to see if the measurement is set to English (Imperial) or Metric units if (acCurDb.Measurement == MeasurementValue.English) { width = new Vector3d((acRasterDef.ResolutionMMPerPixel.X * acRaster.ImageWidth) / 25.4, 0, 0); height = new Vector3d(0, (acRasterDef.ResolutionMMPerPixel.Y * acRaster.ImageHeight) / 25.4, 0); } else { width = new Vector3d(acRasterDef.ResolutionMMPerPixel.X * acRaster.ImageWidth, 0, 0); height = new Vector3d(0, acRasterDef.ResolutionMMPerPixel.Y * acRaster.ImageHeight, 0); } // Define the position for the image Point3d insPt = new Point3d(5.0, 5.0, 0.0); // Define and assign a coordinate system for the image's orientation CoordinateSystem3d coordinateSystem = new CoordinateSystem3d(insPt, width * 2, height * 2); acRaster.Orientation = coordinateSystem; // Set the rotation angle for the image acRaster.Rotation = 0; // Add the new object to the block table record and the transaction acBlkTblRec.AppendEntity(acRaster); acTrans.AddNewlyCreatedDBObject(acRaster, true); // Connect the raster definition and image together so the definition // does not appear as "unreferenced" in the External References palette. RasterImage.EnableReactors(true); acRaster.AssociateRasterDef(acRasterDef); if (bRasterDefCreated) { acRasterDef.Dispose(); } } // Save the new object to the database acTrans.Commit(); // Dispose of the transaction } } VBA/ActiveX 代码参考Sub AttachRasterImage() Dim insertionPoint(0 To 2) As Double Dim scalefactor As Double Dim rotationAngle As Double Dim imageName As String Dim rasterObj As AcadRasterImage imageName = "C:/AutoCAD/sample/VBA/WorldMap.TIF" insertionPoint(0) = 5 insertionPoint(1) = 5 insertionPoint(2) = 0 scalefactor = 2 rotationAngle = 0 On Error GoTo ERRORHANDLER ' Attach the raster image in model space Set rasterObj = ThisDrawing.ModelSpace.AddRaster(imageName, insertionPoint, _ scalefactor, rotationAngle) ZoomAll Exit Sub ERRORHANDLER: MsgBox Err.Description End Sub 父主题: |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2025-1-8 19:32
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.